
//------------------------------------------------------------------------------
// module:   canChannel.h
// created:  P.K. Bartkiewicz, 06.05.2003
// modification history:
//
//------------------------------------------------------------------------------


#ifndef __CANDRIVER_H__
#define __CANDRIVER_H__

#include <stdio.h>
#include <termios.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h> 
    
#include "timeSlice.h"
#include "hrtimer.h"
#include "canMessage.h"
#include  "msgQueue.h"
#include "pcan.h"  // PEAK-SYSTEMS CAN DRIVER


const unsigned char  PCAN_USB = 32;
const unsigned char  PCAN_104 = 8; 

// and other PCAN interafces come here....

class CanDriver : public TimeSlice
{
private:
    int  fdCAN;
    char device[256];
    unsigned int speed;
    void closeCAN();
    void openCAN(unsigned int speed );
    int  readMsg( CanMessage& m );
    virtual int  sendMsg( CanMessage& m, long timeout );
    virtual inline int  sendMsg( CanMessage& m ) { return sendMsg( m, 0 ); }
    virtual int  receiveMsg( CanMessage& m, long timeout );
    virtual inline int  receiveMsg( CanMessage& m ) { return receiveMsg(m, 0 ); }
protected:
    CANmsgQueue sendQueue;
    CANmsgQueue receiveQueue;

 public:
    int Error;
    CanDriver();
    CanDriver( unsigned char interfaceCode, unsigned int speed );

    ~CanDriver();
    
    inline  char * getDevice() { return device; }
    virtual int initialize( unsigned int speed );
    virtual void activate();
    virtual int send( CanMessage &m );
    virtual int receive( CanMessage &m );
};

#endif
