

#include "canMessage.h"
 
extern Log Lg;

CanMessage::CanMessage()
{
  id = 0;
  rtr = 0;
  dataLen = 0;
  idMask = CAN_MESSAGE_DEFAULT_ID_MASK;
  memset( (char*)data, '\0', 8 );            
}

CanMessage::CanMessage( short idBits, char dataBytes[], char dataSize )
{
  id = idBits;
  memcpy( (char*)data, (char*)dataBytes, dataLen = dataSize );      
  rtr = 0;  
  idMask = CAN_MESSAGE_DEFAULT_ID_MASK;
}

CanMessage::CanMessage( short idBits, char data0, char data1, char data2, char data3, char data4, char data5, char data6, char data7 )
{
  
  id = idBits;
  dataLen = 8;
  rtr = 0; 
  idMask =  CAN_MESSAGE_DEFAULT_ID_MASK;
  data[0] = data0;
  data[1] = data1;
  data[2] = data2;
  data[3] = data3; 
  data[4] = data4; 
  data[5] = data5;
  data[6] = data6; 
  data[7] = data7;

}

void CanMessage::dump()
{
  Lg << DBG << "CAN message:" << endl;
  Lg << DBG << "ID = " << hex << "0x" << id << dec << endl;
  if( rtr ) Lg << DBG  << "RTR" << endl;
  else      Lg << DBG << "standard message (no RTR)" << endl;
  for( int i = 0;  i < dataLen; i++ ) Lg << DBG << "data[" << i << "] = "<< (unsigned int)data[i] << hex << ", 0x" << (unsigned int)data[i] << dec << endl;
}
