

#ifndef __CAN_MESSAGE__
#define __CAN_MESSAGE__

#include <string.h>
#include "loggerClass/log.h"
using namespace std; 
#include <iostream>

const int MSG_DATA_LEN               = 8;
const int UNEXPECTED_START_BYTE      = -10;
const int UNEXPECTED_DATA_BYTE       = -11;
const int CRC_ERROR                  = -12;
const int TRANSM_TIMEOUT             = -13;
const int MSG_NOT_READY              = -14;
const int TRANSM_SPEED_NOT_SUPPORTED = -15;
const int CAN_MESSAGE_DEFAULT_ID_MASK = 0x7F;

class CanMessage
{
 private:
  short id;       // 11 bits of the message id
  unsigned char  dataLen;
  unsigned char  data[8];
  unsigned char  rtr;      // 1 bit 
  unsigned short idMask;   // shows, where the node id bits are stored.

 public: 
  CanMessage();
  CanMessage( short idBits, char dataBytes[], char dataSize );
  CanMessage( short idBits, char data0, char data1, char data2, char data3, char data4, char data5, char data6, char data7 );
  void dump();
  inline void setData( char dataBytes[], char dataSize ) { memcpy( (char*)data, (char*)dataBytes, dataLen = dataSize ); }
  inline void setData( char dataBytes[] ) { memcpy( (char*)data, (char*)dataBytes, dataLen = 8 ); }
  inline int getDataLen( void ) { return dataLen; }
  inline void setDataLen( char dLength ) { dataLen = dLength; }
  inline void getData( char buff[], char * size ) {  memcpy( (char*)buff, (char*)data, dataLen); *size = dataLen; }  
  inline unsigned char * getData( void ) { return data; }
  inline short getId( void ) { return id; }
  inline void setId( short idBits ) { id = idBits; }
  inline short isRTR( void ) { return rtr; }
  inline void setRTR( void ) { rtr = 1; }
  inline unsigned char getIdMask( void ) { return idMask; }
  inline void setIdMask( unsigned char mask ) { idMask = mask; }
 
};


#endif
