

#ifndef __CAN_MESSAGE_DISPATCHER__
#define __CAN_MESSAGE_DISPATCHER__

#include "timeSlice.h"
#include "canMessage.h"
#include "canNodeImage.h"
#include "canDriver.h"


extern Log Lg;
const int  MAX_CNI_OBJECTS = 128;

class CanMessageHandler
{
    private:
	CanNodeImage * target;
	int (CanNodeImage::*messageHandler)(int data, CanMessage& cm);
	int data;
    public:
	inline CanMessageHandler() { data = 0; target = NULL; messageHandler = NULL; }
	inline void setData( int d ) { data = d; }
	inline void setTarget( CanNodeImage * t) { target = t; }
	inline void setHandler( int (CanNodeImage::*cmh)(int data, CanMessage& cm)) { messageHandler = cmh; }
	inline int getData() {return data;}
	inline CanNodeImage * getTarget() { return target; }
	inline int (CanNodeImage::*getHandler() )(int data, CanMessage& cm) { return messageHandler; }
};

class CanMessageDispatcher: public TimeSlice
{
 private:
  int nCNIobjects;
  CanNodeImage * cniList[MAX_CNI_OBJECTS];
  CanDriver *canDrv;
  CanMessageHandler canMessageHandler[2048];  // CAN 2.A: 11 bits of identifier only
   
 public:
  CanMessageDispatcher(CanDriver * canDriver );
  void activate( void );
  CanNodeImage * searchForCNI( unsigned short id );
  bool addCanNodeImage( CanNodeImage * cni );
  bool addMessageHandler( short cobId,  CanNodeImage * messageTarget, int (CanNodeImage::*mh)(int data, CanMessage& cm), int data);
};

#endif
