//: dbfile.h:  readin class for csv files
#ifndef _DBFILE_H
#define _DBFILE_H

#include "nihash.h"
#include <fstream>
#include <iostream>
using namespace std;

const int MAX_BUFFER_SIZE = 256;

class DbCsv {
  char token;
  char  buf[MAX_BUFFER_SIZE];
  int primesize;
  int tsize;
  int pos[100]; // kludge
  CoalHashTableNI* iniHash;
public:
  DbCsv(int primesize, char tok);
  ~DbCsv();
  int initHeader(ifstream* dbin);
  int readHeader(char* headerLine);
  int getNextLine(ifstream* dbin);
  int readLine(char* headerLine);
  char* stringv(char* name);
  int intv(char* name);
  float floatv(char* name);
};
#endif

// NOTE: could also have implementation wo hashtable, with user binding indices
// to names in array:  eg int  devname = db->getIndex("DEVNAME") etc, with names 
