#ifndef __EDS_PARSER_H__
#define __EDS_PARSER_H__

// parser for EDS/DCF in Win.ini filie format

#include "loggerClass/log.h"
#include "tools.h"

const int  MAX_LINE_LENGTH  = 255;
const int  MAX_FILE_NAME    = 128;
const int  MAX_SECTION_NAME =  32;
const int  MAX_NODE_NAME = 32;
const int  MAX_WORDS = 10;

extern Log Lg;

class EDSparser
{
 private:
  
  int currentIndex;
  int currentSubindex;
  char currentSectionName[MAX_SECTION_NAME+1];
  char filename[MAX_FILE_NAME+1];  
  void * parserCaller;
  void (* sectionCallback )( void * object, char * section, char * keyname, char * value );
  void (* objectDictionaryCallback )( void * object, int index , int subindex, char *keyname, char * value, int lineNumber );
  void construct(void * owner, char * fname );

 public:
  EDSparser();
  EDSparser( void * owner, char * fname );
  inline void setOwner( void * owner ) { parserCaller = owner; }
  inline void setFileName( char * fname  ) { strncpy( filename, fname, MAX_FILE_NAME); filename[MAX_FILE_NAME] = '\0'; }
  int parse();
  int parse( void * owner,  char *fname, void (* scb )(void *, char *, char *, char *), void (*odcb)(void *, int, int, char *, char *, int) ); 
  inline void setSectionCallback( void (* cb )(void * object, char * section, char * keyname, char * value ) )  { sectionCallback = cb; }
  inline void setObjectDictionaryCallback( void (* cb )(void * object, int index, int subindex, char * keyname, char * value , int lineNumber) ) { objectDictionaryCallback = cb; }
};

#endif
