#include "hrtimer.h"

HrTimer::HrTimer()
{
  interval = 0;
}

long long  HrTimer::hrtimer()
{                                  
  struct timeval tb;
  long long int tsec;

  gettimeofday( &tb, NULL );
  tsec = tb.tv_sec;
  return tsec * 1000 +  tb.tv_usec/1000;   // miliseconds
}

long HrTimer::unixTimestamp()
{
  struct timeval tb;
  gettimeofday( &tb, NULL );
  return tb.tv_sec;  // seconds
}

void HrTimer::toString( long long t, char * buff )
{
  unsigned int milisec = t % 1000;
  unsigned int unixTime = (unsigned int)(t/1000);
  struct tm * tms = localtime((time_t*) &unixTime);
  
  sprintf( buff, "%02d:%02d:%02d.%03d", 
	   tms->tm_hour, tms->tm_min, tms->tm_sec, milisec);
}

void HrTimer::toString( long long tEnd, long long tStart, char * buff )
{
  unsigned int t = (unsigned int)(tEnd - tStart);
  unsigned int milisec = t % 1000;
  unsigned int unixTime = (unsigned int)(t/1000);
  struct tm * tms = gmtime((time_t*) &unixTime);
  
  sprintf( buff, "%02d:%02d:%02d.%03d", 
	   tms->tm_hour, tms->tm_min, tms->tm_sec, milisec);
}

long HrTimer::milisecondsAfterMidnight()
{
  struct timeval tb;
  long long int tsec;

  gettimeofday( &tb, NULL );
  tsec = tb.tv_sec;
  struct tm * tms = localtime((time_t*) &tsec);  
  return ((tms->tm_hour * 60 + tms->tm_min) * 60 + tms->tm_sec ) * 1000 +  tb.tv_usec/1000;   // miliseconds since midnight
}

