#ifndef __HRTIMER_H__
#define __HRTIMER_H__

#include <sys/time.h>
#include <time.h>
#include <stdio.h>

class HrTimer
{
 private:
  long long int interval;
  long long int expiredTime;

 public:
  HrTimer();
  HrTimer(long long int ms) { start( ms ); }
  inline long long int getInterval() { return interval; }
  inline int expired() { return ( hrtimer() >= expiredTime ); }
  inline void start( long long int ms ) { expiredTime = hrtimer() + (interval = ms); }
  inline void restart() { expiredTime = hrtimer() + interval; }
  static long milisecondsAfterMidnight();
  static long long int hrtimer();
  static void toString( long long t, char * buffer );
  static void toString( long long tEnd, long long tStart, char * buff );
  static long unixTimestamp();
};

inline long long gethrtime() 
{                                     // SWH: nsec for compat with Sun Call, KB hrtime returns msec as long64
  return 1000000*HrTimer::hrtimer();
 }
#endif
