#ifndef __LINKED_LIST_H__
#define __LINKED_LIST_H__


#include <stdlib.h>
#include <string.h>

typedef struct list_item
{
  struct list_item * previous;
  struct list_item * next;
  void * data;
  int dataBufferAllocated;
} LISTITEM;


class LinkedList
{ 

 private:
  int nElements;
  LISTITEM * first;
  LISTITEM * current;
  LISTITEM * last;

 public:
  LinkedList();
  ~LinkedList();

  void * add( void * data );
  void * add( void * data, int sizeOfData );
  void removeCurrent();
  void * getCurrent();
  void * getCurrentGoToNext();
  void * getCurrentGoToPrevious();
  int goToNext();
  int goToPrevious();
  inline int getListLen() { return nElements; }
  inline int hasNext() { return ( current->next != NULL ); }
  inline int hasPrevious() { return ( current->previous != NULL ); }
  inline void goToFirst() {  current = first; }
  inline void goToLast()  {  current = last; }
  inline void move( LISTITEM * item ) { current = item; }
  inline int isLast() { return current == last; }
  inline int isFirst() { return current == first; }
  inline LISTITEM * getCurrentListItem() { return current; }
};
#endif
