

#include "log.h"

Log::Log( char * processName )
{
    console = false;
    opened = false;
    loggingLevel = MSG_DBG;  // all messsages logged by default
    messageLevel = MSG_DBG;
    
    if( openLog( processName ) )
    {
      cout << endl;
      cout << "WARNING: can not open log. Check if process 'logman' is running." << endl;
      cout << "WARNING: Messages will be sent only to console." << endl;
      cout << endl;     
      console = true;
    }
    else opened = true;
	
}

Log::~Log()
{ 
  closeLog();
  
}

Log& Log::operator << (ios_base& (*f)(ios_base&) )
{
      if(f == (struct std::ios_base &(*)(struct std::ios_base &))LOG_DBG)
      {
        messageLevel = MSG_DBG;
        return *this;
      }
      if(f == (struct std::ios_base &(*)(struct std::ios_base &))LOG_WARNING)
      {
        messageLevel = MSG_WARNING;
        return *this;
      }      
      if(f == (struct std::ios_base &(*)(struct std::ios_base &))LOG_ERROR)
      {
        messageLevel = MSG_ERROR;
        return *this;
      }      
      if(f == (struct std::ios_base &(*)(struct std::ios_base &))LOG_FATAL)
      {
        messageLevel = MSG_FATAL;
        return *this;
      }   
      
     stringstream::operator << ( f );
     return *this;
}

Log& Log::operator << ( ostream& (*f)(ostream &) )
{
  if( messageLevel > loggingLevel ) return * this;
  if( (f == 
       (std::basic_ostream<char, std::char_traits<char> >& (*)(std::basic_ostream<char, std::char_traits<char> >&)) endl) 
      || 
      (f == 
      (std::basic_ostream<char, std::char_traits<char> >& (*)(std::basic_ostream<char, std::char_traits<char> >&)) ends))    
    {
      if( opened )  putLog( str().c_str() );
      if( console ) cout << str() << endl;
      this->str( "" );
    }  
    else stringstream::operator << ( f );
      
  return *this;    
}
