
#ifndef __LOG_H__
#define __LOG_H__


#include "../shmlogger/shmlogger.h"

using namespace std; 
#include <locale>
#include <iostream>
#include <sstream>

#define FATAL   Log::LOG_FATAL
#define ERROR   Log::LOG_ERROR
#define INFO    Log::LOG_ERROR
#define WARNING Log::LOG_WARNING
#define DBG     Log::LOG_DBG

#define MSG_FATAL   0
#define MSG_ERROR   1
#define MSG_WARNING 2
#define MSG_DBG     3


class Log : public std::stringstream
{
private:
    bool console;
    bool opened;
    int  loggingLevel;
    int  messageLevel;
public:
    Log( char * processName );
    ~Log();

    inline bool setConsoleMode( bool mode )
    {
	bool prev_mode = console;
	console = mode;
	return prev_mode;
    }
    inline void setName( char * pname ) { setProcessName( pname); }
    inline bool getConsoleMode() { return console; } 
    inline int getLoggingLevel() { return loggingLevel; }
    inline int setLoggingLevel( int l ) { int p = loggingLevel; loggingLevel = l; return p; }
    inline int setDebugLevel()   { return setLoggingLevel( MSG_DBG ); }
    inline int setWarningLevel() { return setLoggingLevel( MSG_WARNING ); }
    inline int setErrorLevel()   { return setLoggingLevel( MSG_ERROR ); }
    inline int setFatalLevel()   { return setLoggingLevel( MSG_FATAL ); }

    static inline ios_base& LOG_FATAL(ios_base& __base) { return __base; }
    static inline ios_base& LOG_ERROR(ios_base& __base) { return __base; }
    static inline ios_base& LOG_WARNING(ios_base& __base) { return __base; }
    static inline ios_base& LOG_DBG(ios_base& __base) { return __base; }
  
    Log& operator << ( ostream& (*f)(ostream &) );
    Log& operator << (ios_base& (*f)(ios_base&) );
    
    
    template <class T> Log& operator<< (T arg)
    {
      if( messageLevel <= loggingLevel ) *(std::stringstream*)this << arg;
      return * this;
    }
};

#endif
