/* 
 * File:   MotorolaSrecordReader.h
 * Author: karol
 *
 * Created on November 26, 2008, 5:20 PM
 */

#ifndef __MOTOROLASRECORDREADER_H__
#define	__MOTOROLASRECORDREADER_H__

#include <iostream>
#include <fstream>
using namespace std;

class MotorolaSrecordReader
{
    private:
        static const int MAX_CHARS = 600;   /* you should always assume that a record can have 255*2 characters + header */

        char * output;
        int  maxOutputSize;
        int  outputSize;
        char fileName[256];
        unsigned int dataByteSum;
        int processLine( char * line );
        int S1record( char * buff, int len );
        int S2record( char * buff, int len );
        int S3record( char * buff, int len );
        int processRecord( int crc,  char * buffer, int len );
        unsigned int getValueFromHexPair( unsigned char c, unsigned char d);
        unsigned int getValueFromHexChar( unsigned char c );
        int checkBaseAddress(char * buff);
        
    public:
        static const int OK                    = 0;
        static const int LINE_TOO_SHORT        = 1;
        static const int LINE_ODD_CHARACTERS   = 2;
        static const int NO_S_RECORD_INDICATOR = 3;
        static const int CRC_ERROR             = 4;
        static const int UNKNOWN_S_RECORD_TYPE = 5;
        static const int CANT_OPEN             = 6;
        static const int NO_ROOM               = 7;
        static const int WRONG_BASE_ADDRESS    = 8;
        static const int BASE_ADDRESS          = 0xFFE;  // baase address required by B.Pawlowski's reprogramming system

        MotorolaSrecordReader( char * fileName );
        int convert( char * buffer, int maxSize );
        inline void setFileName(char *name) {strncpy(fileName, name, 255); fileName[255] = '\0';}
        inline int getDataSize() { return outputSize; }
        inline int getDataByteSum() { return dataByteSum; }
};


#endif	/* __MOTOROLASRECORDREADER_H__ */

