
//------------------------------------------------------------------------------
// module:   msgQueue.cpp
// created:  P.K. Bartkiewicz, 23.01.2003
// modification history:
//
//------------------------------------------------------------------------------


#include <stdio.h>
#include "msgQueue.h"

/*
template<class T>
MsgQueue<T>::MsgQueue()
{
  rdPtr = wrPtr = 0;
}
*/

CANmsgQueue::CANmsgQueue()
{
  rdPtr = wrPtr = 0;
}

CANmsgQueue::~CANmsgQueue()
{
}


bool CANmsgQueue::put( CanMessage& m )
{
  register int wptr = wrPtr;
  register int rptr = rdPtr;

  
  if( ++wptr == MAX_QUEUE ) wptr = 0;
  if( wptr == rptr ) return false;     /* queue full */
    
  memcpy( &msg[wptr], &m, sizeof(CanMessage) );
  wrPtr = wptr;

  return true;
}

//template<class T>
bool CANmsgQueue::get( CanMessage& m )
{ 
  register int wptr = wrPtr;
  register int rptr = rdPtr;

  if( wptr == rptr ) return false;     /* queue empty */
  if( ++rptr == MAX_QUEUE ) rptr = 0;

  memcpy( &m, &msg[rptr], sizeof(CanMessage) ); 
  rdPtr = rptr;
 
  return true;
}

//template<class T>
int CANmsgQueue::getNpending()
{
  register int d = wrPtr - rdPtr;
  return (d < 0) ? ( MAX_QUEUE + d ) : d; 
}

//----------------------------------------------------------------------------
// copy (in order to avoid templates) of msgQueue for SDOfwd 
//----------------------------------------------------------------------------


SDOfwdMsgQueue::SDOfwdMsgQueue()
{
  rdPtr = wrPtr = 0;
}

SDOfwdMsgQueue::~SDOfwdMsgQueue()
{
}


bool SDOfwdMsgQueue::put( SDOfwd& m )
{
  register int wptr = wrPtr;
  register int rptr = rdPtr;

  
  if( ++wptr == SDO_FWD_MAX_QUEUE ) wptr = 0;
  if( wptr == rptr ) return false;     /* queue full */
    
  memcpy( &msg[wptr], &m, sizeof(SDOfwd) );
  wrPtr = wptr;

  return true;
}

//template<class T>
bool SDOfwdMsgQueue::get( SDOfwd& m )
{ 
  register int wptr = wrPtr;
  register int rptr = rdPtr;

  if( wptr == rptr ) return false;     /* queue empty */
  if( ++rptr == SDO_FWD_MAX_QUEUE ) rptr = 0;

  memcpy( &m, &msg[rptr], sizeof(SDOfwd) ); 
  rdPtr = rptr;
 
  return true;
}

//template<class T>
int SDOfwdMsgQueue::getNpending()
{
  register int d = wrPtr - rdPtr;
  return (d < 0) ? ( SDO_FWD_MAX_QUEUE + d ) : d; 
}
