
//------------------------------------------------------------------------------
// module:   msgQueue.h
// created:  P.K. Bartkiewicz, 23.01.2003
// modification history:
//   27.11.2006, Karol:  adopted to CANopen Manager Project
//------------------------------------------------------------------------------


#ifndef __MSG_QUEUE_H__
#define __MSG_QUEUE_H__

#include <stdlib.h>
#include "canMessage.h"
#include "sdoFwd.h"

#define MAX_QUEUE 500


class CANmsgQueue
{
 private:
  int rdPtr;
  int wrPtr;
  CanMessage msg[MAX_QUEUE];

 public:
              CANmsgQueue();
	     ~CANmsgQueue();
  bool        put( CanMessage& m );
  bool        get( CanMessage& m );
  int         getNpending();
  inline void flush() { rdPtr = wrPtr = 0; }
  inline bool available() { return !( getNpending() == MAX_QUEUE ); }
};

#define SDO_FWD_MAX_QUEUE 32
class SDOfwdMsgQueue
{
 private:
  int rdPtr;
  int wrPtr;
  SDOfwd msg[SDO_FWD_MAX_QUEUE];

 public:
              SDOfwdMsgQueue();
	     ~SDOfwdMsgQueue();
  bool        put( SDOfwd& m );
  bool        get( SDOfwd& m );
  int         getNpending();
  inline void flush() { rdPtr = wrPtr = 0; }
  inline bool available() { return !( getNpending() == SDO_FWD_MAX_QUEUE ); }
};

//template class msgQueue<CanMessage>;


#endif
