#ifndef __NODEGUARD_H__
#define __NODEGUARD_H__

 
#include "loggerClass/log.h"
#include "canMessageCollector.h"
#include "hrtimer.h"
#include "tineServer.h"


class NodeGuardProducer : public TimeSlice
{
 private:
  CanMessageCollector * cmc;
  unsigned int nodeGuardId;  
  unsigned int ownerId; 
  HrTimer Timer;
  long int interval;
  bool enabled;
 
public:

  NodeGuardProducer();
  void activate();
  inline void connectMessageCollector( CanMessageCollector * collector ) { cmc = collector; }
  inline bool isEnabled() { return enabled; }
  inline void enable() { if( !enabled ) Timer.start(interval); enabled = true;  }
  inline void disable() { enabled = false; }
  inline bool setEnable( bool en ) { bool tmp = enabled; if( en ) enable(); else disable(); return tmp; }
  inline void setInterval( long int ms ) { interval = ms; if(enabled) Timer.start( ms ); }
  inline long getInterval() { return interval; }
  inline void setId( short nid ) { nodeGuardId = nid; };
  inline short getId() { return nodeGuardId; }
  inline void setOwnerId( int id ) { ownerId = id; nodeGuardId = nodeGuardId + 0x700; }
};


#endif
