// 
// File:   SDOforwarder.h
// Author: karol
//
// Created on December 14, 2007, 3:58 PM
//

#ifndef __SDOFORWARDER_H__
#define	__SDOFORWARDER_H__

#include "timeSlice.h"
#include "msgQueue.h"
#include "sdo.h"


class SDOforwarder: public TimeSlice
{
 
  private:
      int state;
      int blocked;
      SDOfwd sdoFwd;
      SDOfwdMsgQueue inputQueue;
      SDOclient * sdoClient;
      int processSDOresponse();
      int submitSDO( SDOfwd& s );
      void removeAwaitingSDOs();

  public:
      static const int IDLE = 0;
      static const int BUSY = 1;      
      static const int WRITE = 2;

      static const int SDO_REJECTED = 0x00008000;
      static const int SDO_DONE = 0x80000000;

      void activate();
      SDOforwarder( SDOclient * );  
      inline int put( SDOfwd& s ) { return isBlocked() ? -1 : ( inputQueue.put(s) == 1 ? 0 : -1 ); }   //reversed logic: return 0 on success
      inline int put( int index, int subindex, void * data, int dataType, int * result , int command )
      {
          if( isBlocked() ) return -1;
          SDOfwd sf;
          sf.set( index,subindex,data,dataType,result,command );       
          return put( sf );
      }
      inline int available()     { return !isBlocked() && inputQueue.available(); }
      inline int getNpending()   { return inputQueue.getNpending(); }
      inline int isIdle()        { return (state == IDLE); }
      inline void setBlocked( int b ) { blocked = b; }
      inline int isBlocked()     { return blocked; }
};


#endif	/* __SDOFORWARDER_H__ */

