

#ifndef __SHMLOGGER_H__
#define __SHMLOGGER_H__

#include <sys/types.h>
#include <unistd.h>
    
#define MAX_PROCESS_NAME 16
#define MAX_MESSAGE      256
  
typedef struct
{
    long timeStamp;
    long  pid;
    char   pName[MAX_PROCESS_NAME+1];
    char   message[MAX_MESSAGE+1];    
} LOGMSG;

#ifdef __cplusplus
extern "C"
{
#endif
  int   openLog( char * processName );
  int   closeLog( void );
  void  putLog( const char * msg );
  void  vPutLog( char *msg, ... );
  int   getLog( LOGMSG * msg );
  int   initLog( char * processName );
  int   getLogInfo( long * lastWritePtr,  long * bufferSize );
  int   readLog( long msgNo, LOGMSG * msg );
  char  terminalMode( char t );
  void  setProcessName( char * processName );
#ifdef __cplusplus
}
#endif
 
#endif
