#ifndef __SYNC_H__
#define __SYNC_H__


#include "canMessageCollector.h"
#include "hrtimer.h"
#include "tineServer.h"

class SyncProducer :  public TineDevice
{
 private:
  CanMessageCollector * cmc;
  HrTimer Timer;
  long int interval;
  bool enabled;
  short syncId;

  struct ph
  {
    char name[33];
    int (SyncProducer::*handler)( TINE_ARGS );
  }  propertyHandlerList[5];
 public:

  SyncProducer( CanMessageCollector * collector );

  void activate();
  void dump();
  inline bool isEnabled() { return enabled; }
  inline void enable() { if( !enabled ) Timer.start(interval); enabled = true;  }
  inline void disable() { enabled = false; }
  inline bool setEnable( bool en ) { bool tmp = enabled; if( en ) enable(); else disable(); return tmp; }
  inline void setInterval( long int ms ) { interval = ms; if(enabled) Timer.start( ms ); }
  inline long getInterval() { return interval; }
  inline void setSyncId( short id ) { syncId = id; }
  inline short getId() { return syncId; }

  // TINE RPC handlers
  void addProperty( char * propName, DTYPE * out, DTYPE *in, short acc, char * dsc, int (SyncProducer::*h)( TINE_ARGS ));
  int propertyHandler( char *property,TINE_ARGS );
  int property_Period( TINE_ARGS );
  int property_OnOff(  TINE_ARGS );
  int property_periodOnOff( TINE_ARGS );
};


#endif
