
/* 
   Ticom.cpp   
   Modification history: 
   03.08.07 S. Herb  Main for version with TiCom Library
   05.12.08 Now in Subversion
*/


#include "coInit.h"

const int SysInterval = 5; // msec
const int DtSleep = 0;     //usec

static int nextCall(int dt); 

int main(int argc, char *argv[]) 
{
  Lg.setName( argv[0] );
  Lg.setConsoleMode(true);    // true: put messages also on the screen
  Configurator config;
  config.parse(argc, argv);   
  Lg.setLoggingLevel(config.getLoggingLevel());
  
 TineFec::configure(&config);
 TineFec::init();
  
  coInit(&config);  
  Lg << DBG << "Ticom init done" << endl;
  
  while(1) 
    { 
      coActivate();     // CANopen Bus Handling
      if( nextCall( SysInterval )) SystemCycle(1);  // Tine Handler
      if( DtSleep ) usleep( DtSleep );  
    }
  return 0;
}

int nextCall(int dt) 
{ // dt in msec
  static long long tlast=0;
  long long tnow = HrTimer::hrtimer();
  if ((tnow - tlast) <  dt) return 0;
  tlast = tnow;
  return 1;
}
