#ifndef __TIMEPRODUCER_H__
#define __TIMEPRODUCER_H__


#include "canMessageCollector.h"
#include "hrtimer.h"
#include "tineServer.h"

class TimeProducer :  public TineDevice
{
 private:
  CanMessageCollector * cmc;
  HrTimer Timer;
  long int interval;
  bool enabled;
  short timeProducerId;
  time_t ReferenceDate;
  long recentDateStamp;
  long recentTimeStamp;
  struct ph
  {
    char name[33];
    int (TimeProducer::*handler)( TINE_ARGS );
  }  propertyHandlerList[5];
 public:

  TimeProducer( CanMessageCollector * collector );

  void activate();
  void dump();
  inline bool isEnabled() { return enabled; }
  inline void enable() { if( !enabled ) Timer.start(interval); enabled = true;  }
  inline void disable() { enabled = false; }
  inline bool setEnable( bool en ) { bool tmp = enabled; if( en ) enable(); else disable(); return tmp; }
  inline void setInterval( long int ms ) { interval = ms; if(enabled) Timer.start( ms ); }
  inline long getInterval() { return interval; }
  inline void setId( short id ) { timeProducerId = id; }
  inline short getId() { return timeProducerId; }

  // TINE RPC handlers
  void addProperty( char * propName, DTYPE *out, DTYPE *in, short acc, char * dsc, int (TimeProducer::*h)( TINE_ARGS ));
  int propertyHandler( char *property, TINE_ARGS );
  int property_Period( TINE_ARGS );
  int property_OnOff(  TINE_ARGS );
  int property_periodOnOff(  TINE_ARGS );
  int property_timeStamp(  TINE_ARGS );
};


#endif
