
//------------------------------------------------------------------------------
// module:   timeSlice.cpp
// created:  P.K. Bartkiewicz, 23.01.2003
// modification history:
//
//------------------------------------------------------------------------------


#include "timeSlice.h"


TimeSlice::TimeSlice()
{
  lastActivationTime = 0;
  lastActivationElapsedTime = 0;
  strcpy( myName, "TimeSlice" );
  msgLevel = 0;
  nObjects = 0;
}

TimeSlice::~TimeSlice()
{
}

void  TimeSlice::dump() 
{ 
  Lg << ERROR << "--Error: no dump method defined." << endl;
}

bool TimeSlice::add( TimeSlice *o)
{
  if( o == NULL ) return false;
  if( nObjects == MAX_OBJECTS ) return false;
  oList[nObjects++] = o;
  return true;
}

void TimeSlice::activate()
{
  lastActivationTime = HrTimer::hrtimer(); 
  for( int i = 0; i < nObjects; i++ ) oList[i]->activate();
  lastActivationElapsedTime =  HrTimer::hrtimer() - lastActivationTime;
}


int TimeSlice::logLevel( int level )
{
  int p = msgLevel;
 
  if( level == 0 ) 
    {
      Lg << INFO << "log turned OFF" << endl;
      msgLevel = level;
    }
  else
    {
      if( msgLevel != level )
	{
	  msgLevel = level;
	  Lg << INFO << "log turned ON" << endl; 
	}
    }
  return p;
}
