
//------------------------------------------------------------------------------
// module:   timeSlice.h
// created:  P.K. Bartkiewicz, 24.11.2006
// modification history:
//
//------------------------------------------------------------------------------


#ifndef __TIMESLICE_H__
#define __TIMESLICE_H__


#include "hrtimer.h"
#include "loggerClass/log.h"
#include <string.h>

const int MAX_OBJECTS = 127;

extern Log Lg;

class TimeSlice
{

private:
    long long lastActivationTime;    // time in miliseconds from epoach
    long lastActivationElapsedTime;  // in miliseconds
    TimeSlice * oList[MAX_OBJECTS];  // will be replaced by a list
    int  nObjects;
    char myName[32];                 // max 16 characters for name + '\0'
    int msgLevel;

public:
    TimeSlice();
    virtual  ~TimeSlice();
    
    virtual void activate();
    inline long long  getLastActivationTime() { return  lastActivationTime; }
    inline long long  getLastActivationElapsedTime() { return  lastActivationElapsedTime; }
    bool add( TimeSlice * o);
    void setName( char * name ) { strncpy( myName, name, 31 ); myName[31] = '\0'; }
    char * getName() { return myName; }
    virtual void dump();
    int logLevel( int level );
};

#endif
