
#include "tineServer.h"
#include "configurator.h"
#include <sys/utsname.h>
#include <unistd.h>
#include <errno.h>

using namespace std; 
#include <locale>
#include <iostream> 

const int MAX_DEVICES = 129;

//allocation of static variables
  unsigned short TineFec::portOffset;
  char TineFec::fecName[17];
  char TineFec::context[17];
  char TineFec::description[33];
  char TineFec::operatingSystem[33];
  char TineFec::location[33];
  char TineFec::hardware[33];
  char TineFec::responsible[33];

// for C callbaks
int TineServer::nEquipmentModules = 0;
TineHandler* TineServer::tineHandler[MAX_TINE_EQUIPMENT_MODULES];

int (*TineServer::eqmHandlerWrapper[ ])( char *deviceName, char *property, TINE_ARGS)
=
 { 
    TineServer::eqmHandlerWrapper0,
    TineServer::eqmHandlerWrapper1,
    TineServer::eqmHandlerWrapper2,
    TineServer::eqmHandlerWrapper3,
    TineServer::eqmHandlerWrapper4,
    TineServer::eqmHandlerWrapper5,
    TineServer::eqmHandlerWrapper6,
    TineServer::eqmHandlerWrapper7,
    TineServer::eqmHandlerWrapper8,
    TineServer::eqmHandlerWrapper9 
 };

int TineServer::eqmHandlerWrapper0( char *deviceName, char *property, TINE_ARGS)
  {
      return tineHandler[0]->eqmHandler(deviceName,property,dout, din,access);
  }
int TineServer::eqmHandlerWrapper1( char *deviceName, char *property, TINE_ARGS)
  {
      return tineHandler[1]->eqmHandler(deviceName,property,dout, din,access);
  }
int TineServer::eqmHandlerWrapper2( char *deviceName, char *property, TINE_ARGS)
  {
      return tineHandler[2]->eqmHandler(deviceName,property,dout, din,access);
  }
int TineServer::eqmHandlerWrapper3( char *deviceName, char *property, TINE_ARGS)
  {
      return tineHandler[3]->eqmHandler(deviceName,property,dout, din,access);
  }
int TineServer::eqmHandlerWrapper4( char *deviceName, char *property, TINE_ARGS)
  {
      return tineHandler[4]->eqmHandler(deviceName,property,dout, din,access);
  }
int TineServer::eqmHandlerWrapper5( char *deviceName, char *property, TINE_ARGS)
  {
      return tineHandler[5]->eqmHandler(deviceName,property,dout, din,access);
  }
int TineServer::eqmHandlerWrapper6( char *deviceName, char *property, TINE_ARGS)
  {
      return tineHandler[6]->eqmHandler(deviceName,property,dout, din,access);
  }
int TineServer::eqmHandlerWrapper7( char *deviceName, char *property, TINE_ARGS)
  {
      return tineHandler[7]->eqmHandler(deviceName,property,dout, din,access);
  }
int TineServer::eqmHandlerWrapper8( char *deviceName, char *property, TINE_ARGS)
  {
      return tineHandler[8]->eqmHandler(deviceName,property,dout, din,access);
  }
int TineServer::eqmHandlerWrapper9( char *deviceName, char *property, TINE_ARGS)
  {
      return tineHandler[9]->eqmHandler(deviceName,property,dout, din,access);
  }
     
void (*TineServer::eqmInitWrapper[ ])()
= { 
    TineServer::eqmInitWrapper0,
    TineServer::eqmInitWrapper1,
    TineServer::eqmInitWrapper2,
    TineServer::eqmInitWrapper3,
    TineServer::eqmInitWrapper4,
    TineServer::eqmInitWrapper5,
    TineServer::eqmInitWrapper6,
    TineServer::eqmInitWrapper7,
    TineServer::eqmInitWrapper8,
    TineServer::eqmInitWrapper9 
 };

void TineServer::eqmInitWrapper0()
  {
      tineHandler[0]->eqmInit();   
  }
void TineServer::eqmInitWrapper1()
  {
      tineHandler[1]->eqmInit();   
  }
void TineServer::eqmInitWrapper2()
  {
      tineHandler[2]->eqmInit();   
  }
void TineServer::eqmInitWrapper3()
  {
      tineHandler[3]->eqmInit();   
  }
void TineServer::eqmInitWrapper4()
  {
      tineHandler[4]->eqmInit();   
  }
void TineServer::eqmInitWrapper5()
  {
      tineHandler[5]->eqmInit();   
  }
void TineServer::eqmInitWrapper6()
  {
      tineHandler[6]->eqmInit();   
  }
void TineServer::eqmInitWrapper7()
  {
      tineHandler[7]->eqmInit();   
  }
void TineServer::eqmInitWrapper8()
  {
      tineHandler[8]->eqmInit();   
  }
void TineServer::eqmInitWrapper9()
  {
      tineHandler[9]->eqmInit();   
  }

void (*TineServer::eqmExitWrapper[ ])()
= { 
    TineServer::eqmExitWrapper0,
    TineServer::eqmExitWrapper1,
    TineServer::eqmExitWrapper2,
    TineServer::eqmExitWrapper3,
    TineServer::eqmExitWrapper4,
    TineServer::eqmExitWrapper5,
    TineServer::eqmExitWrapper6,
    TineServer::eqmExitWrapper7,
    TineServer::eqmExitWrapper8,
    TineServer::eqmExitWrapper9 
 };

void TineServer::eqmExitWrapper0()
  {
      tineHandler[0]->eqmExit();   
  }
void TineServer::eqmExitWrapper1()
  {
      tineHandler[1]->eqmExit();   
  }
void TineServer::eqmExitWrapper2()
  {
      tineHandler[2]->eqmExit();   
  }
void TineServer::eqmExitWrapper3()
  {
      tineHandler[3]->eqmExit();   
  }
void TineServer::eqmExitWrapper4()
  {
      tineHandler[4]->eqmExit();   
  }
void TineServer::eqmExitWrapper5()
  {
      tineHandler[5]->eqmExit();   
  }
void TineServer::eqmExitWrapper6()
  {
      tineHandler[6]->eqmExit();   
  }
void TineServer::eqmExitWrapper7()
  {
      tineHandler[7]->eqmExit();   
  }
void TineServer::eqmExitWrapper8()
  {
      tineHandler[8]->eqmExit();   
  }
void TineServer::eqmExitWrapper9()
  {
      tineHandler[9]->eqmExit();   
  }

void (*TineServer::eqmBackgroundWrapper[ ])()
= { 
    TineServer::eqmBackgroundWrapper0,
    TineServer::eqmBackgroundWrapper1,
    TineServer::eqmBackgroundWrapper2,
    TineServer::eqmBackgroundWrapper3,
    TineServer::eqmBackgroundWrapper4,
    TineServer::eqmBackgroundWrapper5,
    TineServer::eqmBackgroundWrapper6,
    TineServer::eqmBackgroundWrapper7,
    TineServer::eqmBackgroundWrapper8,
    TineServer::eqmBackgroundWrapper9 
 };

void TineServer::eqmBackgroundWrapper0()
  {
      tineHandler[0]->eqmBackground();   
  }
void TineServer::eqmBackgroundWrapper1()
  {
      tineHandler[1]->eqmBackground();   
  }
void TineServer::eqmBackgroundWrapper2()
  {
      tineHandler[2]->eqmBackground();   
  }
void TineServer::eqmBackgroundWrapper3()
  {
      tineHandler[3]->eqmBackground();   
  }
void TineServer::eqmBackgroundWrapper4()
  {
      tineHandler[4]->eqmBackground();   
  }
void TineServer::eqmBackgroundWrapper5()
  {
      tineHandler[5]->eqmBackground();   
  }
void TineServer::eqmBackgroundWrapper6()
  {
      tineHandler[6]->eqmBackground();   
  }
void TineServer::eqmBackgroundWrapper7()
  {
      tineHandler[7]->eqmBackground();   
  }
void TineServer::eqmBackgroundWrapper8()
  {
      tineHandler[8]->eqmBackground();   
  }
void TineServer::eqmBackgroundWrapper9()
  {
      tineHandler[9]->eqmBackground();   
  }


TineDevice::TineDevice()
{ 
  propertyCounter = 0;
  setName( "tineDevice" );
  setFamilyName( "tineDevice" );  
}

void TineDevice::setEqmCompletion( char * message )
{ 
    SetEqmCompletion( server->getEqmName(), message ); 
}

void TineDevice::addProperty( char * propName, DTYPE * out, DTYPE * in, short acc, char * dsc, void * automaticPropertyObject )
{
   properties[propertyCounter].setName(propName);
   properties[propertyCounter].setAccess(acc);
   properties[propertyCounter].setUserData(automaticPropertyObject);
   properties[propertyCounter].setDescription(dsc);
   properties[propertyCounter].setDataInInfo(in);
   properties[propertyCounter].setDataOutInfo(out);
    
    ++propertyCounter;
}

int TineDevice::propertyHandler( char *property, TINE_ARGS )
{
  Lg << DBG << "not defined property handler. Property = " << property << endl;
  return non_existent_elem;
}


TineProperty * TineDevice::getProperty( char *propertyName )
{
  int i;

  for( i = 0; i < propertyCounter; i++ ) if( !strcmp( propertyName, properties[i].getName() )) return &properties[i];
  return NULL;
}

void TineFec::configure( Configurator * config )
{
    TineFecConfig *fc = config->getTineFecConfig();
    setDefaults();
    
    if( strlen(fc->context) ) setContext( fc->context );
    if( strlen(fc->description) ) setDescription( fc->description );
    if( strlen(fc->fecName) ) setFecName( fc->fecName );
    if( strlen(fc->hardware) ) setHardware( fc->hardware);
    if( strlen(fc->location) ) setLocation( fc->location );
    if( strlen(fc->operatingSystem) ) setOperatingSystem( fc->operatingSystem );
    if( strlen(fc->responsible) ) setResponsible( fc->responsible );
    if( fc->portOffset > -1 ) setPortOffset(fc->portOffset );
}

int TineFec::setDefaults()  // call this first, then use set Properties to overwrite if desired
{    
  struct utsname unameBuff;
  char buff[32];
  char *login;

  defaultClientTimeout = 1;
  MinPollingRate = 1;
  MaxPollingRate = 1;
  SysPoll = 0;  // some select() functions will not wait.
  MaxNumContracts = 150;
  MaxNumClients = 50;
  MaxNumConnections = 100;
  FeclogDepth = 100;
  StartupDebug = TRUE;
  RequireAcknowledgments = TRUE;
  MaxRPCTransportSize = 65535;

  setPortOffset(0);

  // try to assign some defaults (ignored if fecid.csv is used!)
  uname( &unameBuff );
  setFecName( unameBuff.nodename );
  setOperatingSystem( unameBuff.sysname ); 
  setHardware( unameBuff.machine );
  gethostname( buff, 32 );
  setLocation( buff );
  if( (login = getlogin() ) != NULL ) setResponsible( login ); 
  else
  {
    if( (login = getenv( "LOGNAME" )) == NULL ) setResponsible ( "unknown" );
    else setResponsible( login );
  }
  strcpy( description, "Test of TineServer" ); 
  setContext( "TEST" );    
  //int errCode = FindNameServerOnNetwork();
  return 0; //errCode;
}

int TineFec::init(int mode) 
{ 
  // call this after any custom sets
  int errCode=0;
  Lg << "FEC Init Mode: " << ((mode)? "FECID.CSV" : "REGISTER ") << endl;
  if (!mode) errCode = RegisterFecNameEx( fecName, description, operatingSystem, location, hardware, responsible, portOffset, context); 
  if( errCode ) 
    {
      Lg << ERROR << "--Error: RegisterFecNameEx error code: " << errCode << endl;
      return errCode;
    }
  errCode = SystemInit(1);
  if( errCode )  Lg << ERROR << "--Error: SystemInit(1) : " << errCode << endl;
  return errCode;
}

TineServer::TineServer( char * sname )
{
  construct( sname );
}

TineServer::TineServer( char * sname, char *eqpName )
{
  construct( sname, eqpName );
}

TineServer::TineServer()
{
  construct( program_invocation_short_name );  // declared in errno.h
}

// Test Version for swh Server (don't use KB handlersd)
TineServer::TineServer( char * sname, char *eqpName, int mode )
{
  Lg<< INFO << "TineUserServer " << sname << " " << eqpName << endl;
  setServerName(sname,eqpName);
  deviceCounter = 0;
  propertyCounter = 0;
  // no init here!!
}

void TineServer::construct( char * sname )
{
  eqmIndex = -1;   // static eqm handler not assigned
  setServerName( sname );
 
  setEqmBackgroundRate(100);
 
  deviceCounter = 0;
  propertyCounter = 0; 
  
  init(); // make default eqm init
}

void TineServer::construct( char * sname, char *eqpName )
{
  eqmIndex = -1;   // static eqm handler not assigned
  setServerName( sname, eqpName );
 
  setEqmBackgroundRate(100);
 
  deviceCounter = 0;
  propertyCounter = 0; 
  
  init(); // make default eqm init
}

void TineServer::setServerName( char * sn )  
{ 
  strncpy( serverName, sn, 31 ); 
  serverName[31] = '\0'; 
  strncpy( eqmTag, serverName, 3 );
  eqmTag[3] = '\0';
  strcat( eqmTag, "EQ" );  
  char ABC = 65 + nEquipmentModules;
  strncat(eqmTag,&ABC,1);
} 
  
void TineServer::setServerName( char * sn, char * eqpName )  
{  
  strncpy( serverName, sn, 31 );  
  serverName[31] = '\0'; 
  strncpy( eqmTag, eqpName, 6 );
  eqmTag[6] = '\0';
} 

void TineServer::setEqmName(char* eqpName) {  // SWH 11.01.08
  strncpy( eqmTag, eqpName, 6 );
  eqmTag[6] = '\0';
}

// add this for compat with previous SWH 11.01.08
int TineServer::init(void (* eqmInit)(void), int (* eqmHandler)(char *, char *, DTYPE *, DTYPE *, short),
                     void (* eqmBackground)(void),void (* eqmExit)(void), int bgrRate ) {
  setEqmInit(eqmInit);
  setEqmHandler(eqmHandler);
  setEqmBackground(eqmBackground); 
  setEqmExit(eqmExit);
  setEqmBackgroundRate(bgrRate);
  return RegisterEquipmentModule( getServerName(), getEqmName(), MAX_TINE_DEVICES,eqmHandler,eqmInit,
                                  eqmBackground, getEqmBackgroundRate(), eqmExit );
}

int TineServer::init(TineHandler *th)
{
  if( eqmIndex < 0 )
  {
      if( nEquipmentModules == MAX_TINE_EQUIPMENT_MODULES ) return -1;
      eqmIndex = nEquipmentModules++;
  }
  
  tineHandler[eqmIndex] = th;
  setEqmBackgroundRate(th->getBackgroundRate());
  return RegisterEquipmentModule( getServerName(), eqmTag, MAX_TINE_DEVICES, 
                                  eqmHandlerWrapper[eqmIndex], 
                                  eqmInitWrapper[eqmIndex], 
                                  eqmBackgroundWrapper[eqmIndex], 
                                  eqmBackgroundRate, eqmExitWrapper[eqmIndex] );
}

int TineServer::addDevice( TineDevice * dev )
{
  int errCode;

  TineServer::device[TineServer::deviceCounter] = dev;
  errCode = AssignNumModules( eqmTag, deviceCounter +1 );
  if( errCode ) 
    {
      Lg << ERROR << "--Error: Tine::addDevice error code: " << errCode << endl;
      return errCode;
    }

  errCode = RegisterDeviceName( eqmTag, dev->getName(), deviceCounter );
  if( errCode ) 
    {
      Lg << ERROR << "--Error: Tine::addDevice(" << eqmTag << "," << dev->getName() << "," << deviceCounter <<  ") error: " << errCode << endl;
      return errCode;
    }
  
  dev->setServer( this );  // notify device, that is connected to the server (needed for dynamic re-assignment of properties) 
  assignPropertyList(dev);
  ++deviceCounter;

  

  return errCode;
}

int TineServer::assignPropertyList(TineDevice * dev)
{
  TineProperty * p;
  NAME64 n[MAX_PROPERTY];
  int errCode;
  for( int i = 0; i < dev->getPropertyCount(); i++ )
    {
      p = dev->getProperty(i);
      strcpy(n[i].name, p->getName());     
      if( (errCode = addProperty(p)) < 0 ) Lg << WARNING << "-Warning: Can't add property: " << p->getName() << ", errCode = " << errCode << endl;
    }
  return AssignPropertyList(eqmTag, dev->getName(), dev->getFamilyName(), dev->getPropertyCount(), n);   
}

int DefaultTineHandler::eqmHandler(char *deviceName, char *property, TINE_ARGS) 
{
    TineDevice **device = srv->getDevices();
    for( int i = 0; i < srv->getDeviceCount(); i++ )
       {
         if( !strcmp(deviceName,device[i]->getName()))  return device[i]->propertyHandler(property,dout,din,access);
       }
    return -1;
}
